////////////////////////////////////////////////////////////////////////////
//
//  lib.h
//
//	Global Headerfile for ALL Sources 
//
//  - includes all nessecary header files (e.g. uC, IO, UART, SW, Middleware, UI, Application)
//  - useful macros
//  - defines basic data types (uppercase)
//    - UCHAR   unsigned 8 bit
//    - SCHAR   signed 8 bit
//    - UINT    unsigned 16 bit
//    - INT     signed 16 bit
//    - ULONG   unsigned 32 bit
//    - LONG    signed 32 bit
//    - REAL    floating point single (4 byte; c type float)
//    - BOOL    boolean 8 bit (0 = false, others true)
//  
// Note : In my system of programming uppercase names mean : macros, defines, preprocessor, data types (prefixed by T_)
//        Identifiers (variables, functions) have a lowercase prefix for (return) type. The name itself is
//				mixed uppercase and lowercase (e.g. vDropToken, ucCounter, ucUARTReceive, bFirst). In larger
//        projects there are also 2-3 uppercase char section prefixes followed by a _  (e.g. OS_vInitTimer, 
//				UI_vClearScreen, APP_ucProcessKey)
//				This Header file is a small excerpt of my template. It only gathers together the most important things
//				to allow to use this code without significant changes. 
//
//	Author 	: Rene Bllhoff
//  Created : around Jan. 2005
//
//	(c) 2005-2007 by Rene Bllhoff - reneboellhoff (at) gmx (dot) de - 
//
//////////////////////////////////////////////////////////////////////////////
//
//  This source file may be used and distributed without
//  restriction provided that this copyright statement is not
//  removed from the file and that any derivative work contains
//  the original copyright notice and the associated disclaimer.
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//										
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public
//  License along with this source; if not, download it	from
//  http://www.gnu.org/licenses/gpl.html	
//
//////////////////////////////////////////////////////////////////////////// 
  #ifndef __LIB_H__
    #define __LIB_H__
  
      // std include files
  
      #include <stdio.h>
			#include <string.h>

      // used basic types
  
      #define VOID      void              
      #define BOOL      unsigned char     
    
      #define UCHAR     unsigned char     
      #define SCHAR     signed char       
    
      #define UINT      unsigned short    
      #define INT       signed short             
      
      #define ULONG     unsigned long     
      #define LONG      signed long              
    
      #define REAL      float  
      
      #define FALSE     0
      #define TRUE      1         
      
      // useful macros
      
      #define MAX(a,b)  ((a) > (b) ? (a) : (b))
      #define MIN(a,b)  ((a) < (b) ? (a) : (b))
     
     // project includes
     
     #include "parser.h"
     
     
  #endif
