////////////////////////////////////////////////////////////////////////////
//
//  main.c
//
//	Main Parser Demo
//
//  Shows a simple printf (with parameters) on given commands
//  All 4 commands defined in parser_cfg.h are executed
//
//
//	Author 	: Rene Bllhoff
//  Created : around Jan. 2005
//
//	(c) 2005-2007 by Rene Bllhoff - reneboellhoff (at) gmx (dot) de - 
//
//////////////////////////////////////////////////////////////////////////////
//
//  This source file may be used and distributed without
//  restriction provided that this copyright statement is not
//  removed from the file and that any derivative work contains
//  the original copyright notice and the associated disclaimer.
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//										
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public
//  License along with this source; if not, download it	from
//  http://www.gnu.org/licenses/gpl.html	
//
////////////////////////////////////////////////////////////////////////////

  #include "lib.h"
  
  
void vSetLED (UCHAR ucParse, UCHAR *pucParseData)
{
  switch (ucParse)
  {
    case PARSER_LED_ON :
        printf ("LED ON\n\r");
      break;
    case PARSER_LED_OFF :
        printf ("LED OFF\n\r");      
      break;
  }     
}  
  
  
void vIOFuncs (UCHAR ucParse, UCHAR *pucParseData)
{
  switch (ucParse)
  {
    case PARSER_READ_IO :
        printf ("Read IO : %8x\n\r", * ((ULONG *) (pucParseData)) );
      break;
    case PARSER_WRITE_IO :
        printf ("Write IO : %8x %8x\n\r",  * ((ULONG *) (pucParseData)) ,  PARSE_DATA_ULONG (4) );      
      break;
  }      
}  
  
 
void cmain (void)
{
  vParserInit ();
 
  vParserProcessString     ("led  on\x0d");
  vParserProcessString     ("led  off\x0d");
  vParserProcessString     ("read io 0x1234aa55\x0d");
  vParserProcessString     ("write io 0x12345678 0xE15CAFEE\x0d");  
}
